/**********************************************
* PIC24FJ64GA002 family 
*  mp3tets1 : VS1011Ep@MP3eXgP
*  go̓eXg
***********************************************/
#include <p24FJ64GA002.h>

/* RtBM[V rbg̐ݒ  */
_CONFIG1( JTAGEN_OFF & GCP_OFF & GWRP_OFF &	BKBUG_OFF
	 & COE_OFF & ICS_PGx1& FWDTEN_OFF ) 
/* 8MHz*PLL4=32MHz (Full Speed)  */
_CONFIG2( IESO_OFF & FNOSC_FRCPLL & FCKSM_CSDCMD
	 & OSCIOFNC_OFF & IOL1WAY_OFF & I2C1SEL_PRI & POSCMOD_NONE)
typedef unsigned char		BYTE;
/** Delay֐pNbNg`@**/
#define CLOCK 16				// MHz 
/** |[g̒`@*/
#define MP3_DREQ_TRIS			(TRISBbits.TRISB14)	// Data Request
#define MP3_DREQ_IO 			(PORTBbits.RB14)		
#define MP3_XRESET_TRIS		(TRISAbits.TRISA0)	// Reset, active low
#define MP3_XRESET_IO			(LATAbits.LATA0)
#define MP3_XDCS_TRIS			(TRISBbits.TRISB15)	// Data Chip Select
#define MP3_XDCS_IO			(LATBbits.LATB15)
#define MP3_XCS_TRIS			(TRISBbits.TRISB13)	// Control Chip Select
#define MP3_XCS_IO			(LATBbits.LATB13)
/*  SPISPI2gp@*/
#define MP3_SCK_TRIS			(TRISBbits.TRISB12)
#define MP3_SDI_TRIS			(TRISBbits.TRISB10)
#define MP3_SDO_TRIS			(TRISBbits.TRISB11)
#define MP3_SPI_IF			(IFS2bits.SPI2IF)
#define MP3_SSPBUF			(SPI2BUF)
#define MP3_SPICON1			(SPI2CON1)
#define MP3_SPICON1bit			(SPI2CON1bits)
#define MP3_SPICON2			(SPI2CON2)
#define MP3_SPISTAT			(SPI2STAT)
#define MP3_SPISTATbits		(SPI2STATbits)
/* ֐vg^CsO@*/
BYTE WriteSPI(BYTE output);
void Command(BYTE RegAdrs, BYTE UpData, BYTE LowData);
void delay_ms(int msec);
void VS1011_Init(void);
void VS1011_SineTest(void);

/******************************************
* VS1011ego̓eXg̃C֐
******************************************/
int main(void){
	CLKDIV = 0x0100;					// NbN1/1
	/* o̓|[gݒ  */
	AD1PCFG = 0xFFFF;					// ׂăfW^
	TRISA = 0xFFFC;					// RA0,1̂ݏo
	TRISB = 0x470F;					// RB0-3,8,9,10,14
	CNPU1 = 0x10F0;					// CN4,5,6,7,12vAbvL
	CNPU2 = 0x00E1;					// CN16,21,22,23
	/* SPĨst  */
	RPINR20bits.SDI1R = 7;				// SDI1RP7
	RPOR3bits.RP6R = 8;				// SCK1RP6
	RPOR2bits.RP5R = 7;				// SDO1RP5
	RPINR22bits.SDI2R = 10;			// SDI2RP15
	RPOR6bits.RP12R = 11;				// SCK2RP13
	RPOR5bits.RP11R = 10;				// SDO2RP14
	/*@VS1011ȅ@*/
	VS1011_Init();
	/* VS1011̃fobOeXgp̃R}h@@*/
	VS1011_SineTest();								// go̓eXg
	while(1){
	}
}
/************************************
* SPI Read after Write@{֐
************************************/
BYTE WriteSPI(BYTE output){
	MP3_SPI_IF = 0;				// 荞݃tONA
	MP3_SSPBUF = output;			// SPIo
	while(!MP3_SPI_IF);			// ܂Ԃ͑҂
	return MP3_SSPBUF;			// ̓f[^߂l
}
/************************************
*  VS1011pR}ho͊֐
************************************/
void Command(BYTE RegAdrs, BYTE UpData, BYTE LowData){
	MP3_XDCS_IO = 1;				// f[^[h
	while(!MP3_DREQ_IO);			// fB[҂
	MP3_XCS_IO = 0;				// R}h[hݒ 
	WriteSPI(0x02);				// ݓw
	WriteSPI(RegAdrs);			// WX^AhXo
	WriteSPI(UpData);				// ʃoCgo
	WriteSPI(LowData);			// ʃoCgo
	MP3_XCS_IO = 1;				// R}h[h
}
/********************************************
*  VS1011 ֐
*    VS1011][hASDIeXg[h@ɐݒ
*    VS1011ƐɒʐMłȂƉiv҂ƂȂ
*********************************************/
void VS1011_Init(void){
	unsigned int val;
	/***** VS1011p|[g̏ݒ   ***/
	MP3_XDCS_IO = 1;				// DCSHigh
	MP3_XCS_IO = 1;				// XCSHigh
	MP3_XRESET_IO = 0;			// XRESETLow
	MP3_XRESET_TRIS = 0;			// oTRISL
	MP3_DREQ_TRIS = 1;			// DREQ̓[h
	MP3_XDCS_TRIS = 0;			// XDCSo
	MP3_XCS_TRIS = 0;				// XCSo
	MP3_SDI_TRIS = 1;				// SDI2̓[h
	MP3_SDO_TRIS = 0;				// SDO2o̓[h
	MP3_SCK_TRIS = 0;				// SCK2o̓[h
 	/***** SPI2̏ݒ   ***/
	MP3_SPICON1 = 0x003B;			// 8rbg[h,CKP = 0,CLK=Fosc/4 (4MHz)
								// ŃTv(SMP=0) GbWőM(CKE=1)
	MP3_SPICON2 = 0;				// t[[hȂ
	MP3_SPI_IF = 0;				// 荞݃tONA
	MP3_SPISTATbits.SPIEN = 1;		// SPI2Cl[u
	/* RESETAVS1011X^[g  */
	delay_ms(50);					// 50msec delay
	MP3_XRESET_IO = 1;			// RESET
	/** [hݒ@*/
	Command(0x00, 0x08, 0x20);		// [hݒ@V[hASDIeXg[h
	/* NbN_uݒ@*/
	val = 12288 / 2 + 0x8000;		// ݒl߂if[^V[gj
	Command(0x03, (BYTE)(val /256), (BYTE)val);
	delay_ms(10);
}

/********************************************
*  VS1011 geXg[hݒ֐
*    MODESPIeXg[hɐݒ肵ĂKv
*********************************************/
void VS1011_SineTest(void){
	/* eXg[hV[PXo */
	while(!MP3_DREQ_IO);
	MP3_XDCS_IO = 0;
 	// Start Sine Test
	WriteSPI(0x53);
	WriteSPI(0xEF);
	WriteSPI(0x6E);
	WriteSPI(0x7D);				// 22.050kHz Out is 5kHz
	WriteSPI(0x00);
	WriteSPI(0x00);
	WriteSPI(0x00);
	WriteSPI(0x00);
	MP3_XDCS_IO = 1;
}
/****************************
* usecPʃfBC֐
****************************/
void delay_us(int usec){
	usec = (int)(CLOCK*usec)/ 10;
	while(usec)	{
		asm("NOP");
		asm("NOP");
		asm("NOP");
		asm("NOP");
		asm("NOP");					
		usec--;
	}
}
/***************************
* msecPʃfBC֐
***************************/
void delay_ms(int msec){
	int i;
	for(i=0; i< msec; i++)
		delay_us(1000);
}
