/**********************************************
* PIC24FJ64GA002 family 
*  mp3tets2 :
*@@ FAT1t@CVXeeXgvO
***********************************************/
#include <p24FJ64GA002.h>
#include "GenericTypeDefs.h"
#include "FSIO.h"

/* RtBM[V rbg̐ݒ  */
_CONFIG1( JTAGEN_OFF & GCP_OFF & GWRP_OFF &	BKBUG_OFF
	 & COE_OFF & ICS_PGx1& FWDTEN_OFF ) 
/* 8MHz*PLL4=32MHz (Full Speed)  */
_CONFIG2( IESO_OFF & FNOSC_FRCPLL & FCKSM_CSDCMD
	 & OSCIOFNC_OFF & IOL1WAY_OFF & I2C1SEL_PRI & POSCMOD_NONE)
/* FATt@Cp\̂̃|C^ϐ  */
FSFILE *fptr;
size_t result;
BYTE Buffer[256];
#define CLOCK  16
void delay_ms(int msec);

/**************************
* C֐
***************************/
int main(void){
	CLKDIV = 0x0100;					// NbN1/1
	/* o̓|[gݒ  */
	AD1PCFG = 0xFFFF;					// ׂăfW^
	TRISA = 0xFFFC;					// RA0,1̂ݏo
	TRISB = 0x4707;					// RB0-8,9,10,14
	CNPU1 = 0x10F0;					// CN4,5,6,7,12vAbvL
	CNPU2 = 0x00E1;					// CN16,21,22,23
	/* SPĨst  */
	RPINR20bits.SDI1R = 7;				// SDI1RP7
	RPOR3bits.RP6R = 8;				// SCK1RP6
	RPOR2bits.RP5R = 7;				// SDO1RP5
	RPINR22bits.SDI2R = 10;			// SDI2RP15
	RPOR6bits.RP12R = 11;				// SCK2RP13
	RPOR5bits.RP11R = 10;				// SDO2RP14
	LATBbits.LATB3 = 1;				// LED on
	/* J[h̎mFƃfBNgǂݍ iiv҂j */
	while(!FSInit());					// FAT̏
	LATBbits.LATB3 = 0;				// LED Off
	/* t@C̃I[v@*/
	fptr = FSfopen("alde_01.mp3", "r");
	LATBbits.LATB3 = 1;				// LED On
	/* t@CI[vłf[^ǂݏo*/
	if(fptr != 0){
		do{
			/* 256oCgPʂŃt@C[h@*/
			result = FSfread(Buffer, 1, 256, fptr);
			LATB ^= 0x08;				// LED]\
			delay_ms(10);				// 10msec҂		
		} while(result != 0);			// t@CEOF܂Ōp
		/* t@CN[Y	*/
		FSfclose(fptr);
		LATBbits.LATB3 = 0;
	}	
	while(1){
	}
}
/****************************
* usecPʃfBC֐
****************************/
void delay_us(int usec){
	usec = (int)(CLOCK*usec)/ 10;
	while(usec)	{
		asm("NOP");
		asm("NOP");
		asm("NOP");
		asm("NOP");
		asm("NOP");					
		usec--;
	}
}
/***************************
* msecPʃfBC֐
***************************/
void delay_ms(int msec){
	int i;
	for(i=0; i< msec; i++)
		delay_us(1000);
}

