/**********************************************
* PIC24FJ64GA002
*  mp3pocket : VS1011Ep@MP3ĐvO
*  }CN`bvFAT16t@CVXegp
*  SDJ[hMP3̃t@C̓[gɂ̂ݕۑ
*  fBNg͈ĂȂ̂Ŗ
***********************************************/
#include <p24FJ64GA002.h>
#include "GenericTypeDefs.h"
#include "FSIO.h"
#include "VS1011.h"
/* RtBM[V rbg̐ݒ  */
_CONFIG1( JTAGEN_OFF & GCP_OFF & GWRP_OFF &	BKBUG_OFF
	 & COE_OFF & ICS_PGx1& FWDTEN_OFF ) 
/* 8MHz*PLL4=32MHz (Full Speed)  */
_CONFIG2( IESO_OFF & FNOSC_FRCPLL & FCKSM_CSDCMD
	 & OSCIOFNC_OFF & IOL1WAY_OFF & I2C1SEL_PRI & POSCMOD_NONE)
/* FATt@Cp\̂̃|C^ϐ  */
FSFILE *fptr;
size_t result;
BYTE Buffer[256];
SearchRec Record;
SearchRec *rptr = &Record;
int i;
/* MP3pϐ  */
BYTE Volume, ChgFlag, BASS;
/* ֐vg^CsO  */
void CheckSW(void);

/**************************
* C֐
***************************/
int main(void){

	CLKDIV = 0x0100;						// NbN1/2(8MIPS)
	/* o̓|[gݒ  */
	AD1PCFG = 0xFFFF;						// ׂăfW^
	TRISA = 0xFFFC;						// RA0,1̂ݏo
	TRISB = 0x470F;						// RB0-3,8,9,10,14
	CNPU1 = 0x10F0;						// CN4,5,6,7,12vAbvL
	CNPU2 = 0x00E1;						// CN16,21,22,23
	/* XCb`ԕω荞݂̋  */
	CNEN1 = 0x00F0;						// CN4-7(RB0-3)
	IPC4bits.CNIP = 5;
	IEC1bits.CNIE = 1;
	/* SPĨst  */
	RPINR20bits.SDI1R = 7;					// SDI1RP7
	RPOR3bits.RP6R = 8;					// SCK1RP6
	RPOR2bits.RP5R = 7;					// SDO1RP5
	RPINR22bits.SDI2R = 10;				// SDI2RP15
	RPOR6bits.RP12R = 11;					// SCK2RP13
	RPOR5bits.RP11R = 10;					// SDO2RP14

	/*@VS1011ȅ@*/
	VS1011_Init();
	Volume = 0;									// ʂ̏ݒ
	SetVolume(Volume, Volume);
	BASS = 3;									// oXu[Xg̏ݒ
	SetBassBoost(BASS,15);
	/* VS1011̃fobOeXgp̃R}h@@*/
//	VS1011_SineTest();							// go̓eXg
	/* J[h̎mFƃfBNgǂݍ iiv҂j */
	while(!FSInit());								// FAT̏
	/* ŏ̃t@C̃T[`i[gMP3t@C邱ƂOj  */
	result = FindFirst("*.*", ATTR_ARCHIVE, rptr);
	if(result == 0){
		fptr = FSfopen(Record.filename, "r");		// t@C̃I[v
	}
	LATAbits.LATA1 = 1;							// LED On
	/**************** C[v@**********/
	while(1){
		/* yf[^̏o */
		if(fptr != 0){							// ɃI[vłH
			/* t@CEOF܂ŉf[^Ao */
			do{
				/* ʕύX{^`FbNƐ  */
				if(ChgFlag){						// ʕύX肩H
					ChgFlag = 0;
					SetVolume(Volume, Volume);		// ʐݒ
					SetBassBoost(BASS, 15);		// oXu[Xgݒ
				}
				/* yf[^̑M@*/
				SRbits.IPL = 7;					// SPI͊荞݋֎~
				MP3_XDCS_IO = 0;
				/* 256oCgPʂŃt@C[h@*/
				result = FSfread(Buffer, 1, 256, fptr);
				LATAbits.LATA1 = !LATAbits.LATA1;	// LED ]
				for(i= 0; i<result; i++){			// ǂݏooCgJԂ
					SendData(Buffer[i]);			// yf[^M
				}
				SRbits.IPL = 2;					// 荞ݍċ
			} while(result != 0);					// t@CEOF܂Ōp
			MP3_XDCS_IO = 1;
			/* Đ	*/
			FSfclose(fptr);						// t@C̃N[Y
			LATAbits.LATA1 = 0;
			PlayEnd();							// ĐI
			/* AĐ̂ߎ̃t@CT[` */
			result = FindNext(rptr);				// ̃t@C
			if((result==0)&&(Record.attributes==ATTR_ARCHIVE))
				fptr = FSfopen(Record.filename, "r");
			else   /* t@C̏IȂēxŏJԂ  */
				FindFirst("*.*", ATTR_ARCHIVE, rptr);
			SRbits.IPL = 2;						// 荞ݍċ			
		}
	}
}

/******************************************
* XCb`ԕω荞ݏ
*******************************************/
void __attribute__((interrupt, no_auto_psv)) _CNInterrupt(void){
	IFS1bits.CNIF = 0;					// 荞݃tONA
	/* XCb`̃`FbN  */
	if(!PORTBbits.RB0){					// SW1ʃAbv
		if(Volume > 4)					// ō0(0dB)
			Volume -= 4;
		ChgFlag = 1;
	}
	if(!PORTBbits.RB1){					// SW2ʃ_E
		if(Volume < 0xC0)					// Œ0xC0Őij
			Volume += 4;
		ChgFlag = 1;
	}
	if(!PORTBbits.RB2){					// SW3@̃t@C
		FSfclose(fptr);					// ݂̃t@CN[Y
		PlayEnd();						// ĐI
		/* ̃t@CT[` */
		result = FindNext(rptr);			// ̃t@C
		if((result==0)&&(Record.attributes==ATTR_ARCHIVE))
			fptr = FSfopen(Record.filename, "r");
		else
			FindFirst("*.*", ATTR_ARCHIVE, rptr);
	}
	if(!PORTBbits.RB3){					// SW4@BASSu[Xg
		BASS ++;							// BASS BoostAbv
		if(BASS >15)						// 15𒴂0ɖ߂
			BASS = 0;
		ChgFlag = 1;						// ύXtOI
	}
}

